
{{
==== ADC0838 - Axc & Compass Driver ====
---- Jim Miller 2008 ----
}}

VAR
  Byte  bitno,ADTemp,ADdata
  Long  AXTemp,AXData,CMTemp,CMData  
  Long  AD0,AD1,AD2,AD3,AD4,AD5,AD6,AD7
  LONG  AX0, AX1, AX2, AX3
  Long  CM0,CM1
  byte  Chan,ADCog ',AxcCS
  long  ADStack[35]

CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000 

    ' ----------------------- ADC0834 4 - Chan. Mux
        CL = 2  '    CL         ' [CLK] Clock Pin
        DI = 1  '    DI         ' [DI] Data Input pin from Prop to AD
        DO = 3  '    DO         ' [DO] Data Output from AD to Prop
        CS = 0  '    CS         ' [~CS] Chip select - active lo
        SE = 16 '    SE         ' [~SE]
         
        AxCmDat = 8   ' [Dxx] Data I/O line for compass and axcelerometer
        CmEN  = 9     ' [~EN] Compass Enable Line 
        AxcCS = 10    ' [~CS] Axcelerometer Chip Select
        AxcZG = 11    ' [ZG] Axcel Zero G indicator - Free Fall
    
PUB init :Success
  'AxcCS :=10 
  dira[CL] ~~                   ' Clock output
  dira[DI] ~~                   ' Data out from Prop to AD(in)
  dira[DO] ~                    ' Data IN from AD to Prop
  dira[CS] ~~                   ' Chip select - active low
  dira[SE] ~~                   ' SE output
 
  outa[CS] := 0                 ' Turn CS on to non-active state
  outa[CL] := 0                 ' Make sure clock is low
  outa[DI] := 0                 ' Set DI to AD low
  outa[SE] := 0                 ' Set SE active low


  DIRA[AxCmDat] ~             'Set as input to start [Dxx] Data I/O line for compass and axcelerometer
  DIRA[CmEN]  :=1             ' [~EN] Compass Enable Line 
  DIRA[AxcCS] :=1             ' [~CS] Axcelerometer Chip Select
  DIRA[AxcZG] ~               ' [ZG] Axcel Zero G indicator - Free Fall
   
  OUTA[CmEN]  :=1             ' Turn on both active low lines
  OUTA[AxcCS] :=0

  Chan := 0
  ResetCompass
  'Success := cognew(Main, @ADStack)
  coginit(6,Main, @ADStack)
       
PUB Main

  dira[CL] ~~                   ' Clock output
  dira[DI] ~~                   ' Data out from Prop to AD(in)
  dira[DO] ~                    ' Data IN from AD to Prop
  dira[CS] ~~                   ' Chip select - active low
  DIRA[SE] ~~

  DIRA[AxCmDat] ~             'Set as input to start [Dxx] Data I/O line for compass and axcelerometer
  DIRA[CmEN] ~~               ' [~EN] Compass Enable Line 
  DIRA[AxcCS] ~~              ' [~CS] Axcelerometer Chip Select
  DIRA[AxcZG] ~               ' [ZG] Axcel Zero G indicator - Free Fall

  OUTA[CmEN]  :=1             ' Turn on both active low lines
  
  ' Begin Read on 8 chan AD converter  
  Repeat

    PulseCompass
  
    Chan ++                      ' Rotate Channel assignments
    if Chan == 8
      Chan :=0
    Outa[SE] :=1
    Outa[CS] :=0                 ' Chip Select low
    waitcnt((2_000 + cnt))        ' Wait t_setup = 480 nS   
    Outa[DI] ~~                   ' Set Start Bit 
    waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS                               
    ClockAD                       ' Clock 1     
    OUTA[DI] :=1                  ' Set to SGL - (sample type for AD, ie:not diferential)                                             
    ClockAD                       ' Clock 2                                              
    Outa[DI] := ((Chan &  %00000100) >> 2) ' Get Third bit of chan and put it on DI (bit 1)    
    ClockAD                       ' Clock 3                                                    
    Outa[DI] := ((Chan &  %00000010) >> 1) ' Get Second bit of chan and put it on DI (bit 2)
    ClockAD                       ' Clock 4                                                                                                                                             
    Outa[DI] := (Chan &  %00000001)        ' Get First bit of chan and put it on DI (bit 3) 
    ClockAD                       ' Clock 5                                                 
    waitcnt((3_000 + cnt))        ' Wait mux settle time                                        
    OUTA[DI] :=0                  ' Zero data in line                                                                                                                                   
    ClockAD                       ' Clock 6    Add extra clock cycle - 6 on timing diagram  
      
    AdTemp := %10000000           ' Set AdData bit adder to MSB
    AdData := 0                   ' Clear data
    Repeat bitno from 0 to 7      ' Go around 8 times      
      if ina[DO] == 1             ' If the input is a 1
        AdData := AdTemp + AdData ' AD the bit adder to the data byte
      AdTemp := AdTemp >> 1       ' Rotate the bit adder to the next lower bit position
      ClockAD                     ' Clock the AD for the next bit 

    Outa[CS] := 1                  ' Chip Select High
    OUTA[SE] := 1                  'SE to High

    waitcnt((2_000 + cnt))        ' Wait 

    Case Chan
        0: AD0 :=  AdData
        1: AD1 :=  AdData
        2: AD2 :=  AdData
        3: AD3 :=  AdData
        4: AD4 :=  AdData
        5: AD5 :=  AdData
        6: AD6 :=  AdData
        7: AD7 :=  AdData
        
   ' Begin Read on Axcelorometer using Chan 0-3 as count ------------------------------------------
   ' ----------------------------------------------------------------------------------------------                                                            
    if Chan < 4
      Outa[AxcCS] :=0                ' AXc Chip Select low
      
      DirA[AxCmDat] :=1           ' Set data line to output 
      Outa[AxCmDat] :=1             ' Set Start Bit
       
      waitcnt((4_000 + cnt))        ' Wait t_sucs = 240 nS
                                   
      ClockAD                       ' Clock 1     
      OUTA[AxCmDat] :=1             ' Set to SGL - (sample type for AD, ie:not diferential)                                             
      ClockAD                       ' Clock 2                                              
      Outa[AxCmDat] :=0' ((Chan &  %00000100) >> 2) ' Get Third bit of chan and put it on DI (bit 1)    
      ClockAD                       ' Clock 3                                                    
      Outa[AxCmDat] := ((Chan &  %00000010) >> 1) ' Get Second bit of chan and put it on DI (bit 2)
      ClockAD                       ' Clock 4                                                                                                                                             
      Outa[AxCmDat] := (Chan &  %00000001)        ' Get First bit of chan and put it on DI (bit 3) 
      ClockAD                       ' Clock 5                                                 
       
      DIRA[AxCmDat] :=0             ' Shift Data line to input
      waitcnt((3_000 + cnt))        ' Wait mux settle time
                                                                                                                                       
      ClockAD                       ' Clock 6    Add extra clock cycle - 6 on timing diagram  
      'ClockAD                       ' Clock 7    Add extra clock cycle - 6 on timing diagram  
         
      AXTemp := %0001000000000000   ' Set AXData bit adder to MSB        AXTemp,AXData 
      AXData := 0                   ' Clear data
      Repeat bitno from 0 to 11     ' Go around 12 times      
        if ina[AxCmDat] == 1        ' If the input is a 1
          AXData := AXTemp + AXData ' AD the bit adder to the data byte
        AXTemp := AXTemp >> 1       ' Rotate the bit adder to the next lower bit position
        ClockAD                     ' Clock the AD for the next bit 
       
      Outa[AxcCS] := 0                  ' Chip Select High      
      ClockAD                       ' Clock the AD to acknowledge CS change
       
      Case Chan
        0: AX0 := AXData
        1: AX1 := AXData
        2: AX2 := AXData
        3: AX3 := AXData
     
      Outa[AxcCS] :=1               ' AXc Chip Select High      
      DIRA[AxCmDat] :=1             ' Shift Data line to output  

   ' Begin Read on Compass using Chan 0-3 as count ------------------------------------------
   ' ----------------------------------------------------------------------------------------------   
    if Chan == 4                     ' If Chan = 4, start a sample
      ResetCompass
    if Chan == 6                    ' Wait two channel cycles to sample data
      
      Outa[CmEN] :=0                ' Compass Chip Select low     
      DirA[AxCmDat] :=1             ' Set data line to output
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS
      
                                    ' Send 1000 to activate measurement
      OUTA[AxCmDat] :=1             ' 1                              
      ClockAD                       ' Clock 1     
      Outa[AxCmDat] :=0'            ' 1                                    
      ClockAD                       ' Clock 2                                              
      Outa[AxCmDat] :=0'            ' 0
      ClockAD                       ' Clock 3                                                    
      Outa[AxCmDat] :=0'            ' 0
      ClockAD                       ' Clock 4                                             
       
      DIRA[AxCmDat] :=0             ' Shift Data line to input
                                    ' Pulse the enable line              
      Outa[CmEN] :=1                ' Compass Chip Select low
      waitcnt((2_000 + cnt))        ' Wait             
      Outa[CmEN] :=0                ' Compass Chip Select low
                                    ' Clock in 4 bits
         
      CMTemp := %0000000000001000   ' Set CMData bit adder to MSB 
      CMData := 0                   ' Clear data
      Repeat bitno from 0 to 3     ' Go around 4 times      
        if ina[AxCmDat] == 1        ' If the input is a 1
          CMData := CMTemp + CMData ' AD the bit adder to the data byte
        CMTemp := CMTemp >> 1       ' Rotate the bit adder to the next lower bit position
        ClockAD                     ' Clock the AD for the next bit 

      IF (CMData | %0000000000001100) == 0              ' XOR input to see if conversion is done
                                                        ' If conversion is complete then continue loading
        CMTemp := %0000010000000000   ' Set CMData bit adder to MSB
        CMData := 0                   ' Clear data
        Repeat bitno from 0 to 10     ' Go around 11 times
          ClockAD                     ' Clock the AD for the next bit              
          if ina[AxCmDat] == 1        ' If the input is a 1
            CMData := CMTemp + CMData ' AD the bit adder to the data byte
          CMTemp := CMTemp >> 1       ' Rotate the bit adder to the next lower bit position
        CM0 := CMData                 ' First measurement

        CMTemp := %0000010000000000   ' Set CMData bit adder to MSB
        CMData := 0                   ' Clear data
        Repeat bitno from 0 to 10     ' Go around 11 times
          ClockAD                     ' Clock the AD for the next bit              
          if ina[AxCmDat] == 1        ' If the input is a 1
            CMData := CMTemp + CMData ' AD the bit adder to the data byte
          CMTemp := CMTemp >> 1       ' Rotate the bit adder to the next lower bit position
        CM1 := CMData                 ' Second measurement
        
      Outa[CmEN] :=1               ' AXc Chip Select High      
      DIRA[AxCmDat] :=1             ' Shift Data line to output  

       
PUB GetAx(ChanReq) : AxDataOut
     Case ChanReq
        0: AxDataOut := AX0
        1: AxDataOut := AX1
        2: AxDataOut := AX2
        3: AxDataOut := AX3
        
PUB GetAD(ChanReq) : AdDataOut
     Case ChanReq
        0: AdDataOut := AD0
        1: AdDataOut := AD1
        2: AdDataOut := AD2
        3: AdDataOut := AD3
        4: AdDataOut := AD4
        5: AdDataOut := AD5
        6: AdDataOut := AD6
        7: AdDataOut := AD7
PUB GetCompass(ChanReq): CMDataOut
      Case ChanReq
        0: CMDataOut := CM0
        1: CMDataOut := Cm1 
    
PUB ClockAD
      ' ----------------------------- Clock AD ------------------
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS  
      OUTA[CL] := 1                  ' Clock up            
      waitcnt((2_000 + cnt))        ' Wait t_setup = 240 nS
      OUTA[CL] := 0                  ' Clock Down      
      ' ----------------------------- Clock AD ------------------

PUB ResetCompass
      DIRA[AxCmDat] :=1             ' Shift Data line to output
      Outa[CmEN]    :=0             ' Compass Chip Select low      

      waitcnt((2_000 + cnt))        ' Wait 240 nS to stabalize line
      OUTA[AxCmDat] :=1             ' 1                                
      ClockAD                       ' Clock 1     
      Outa[AxCmDat] :=1'            ' 1                                              
      ClockAD                       ' Clock 2                                              
      Outa[AxCmDat] :=0'            ' 0
      ClockAD                       ' Clock 3                                                    
      Outa[AxCmDat] :=0'            ' 0 
      ClockAD                       ' Clock 4                                                                                                                                             

      Outa[CmEN] := 1               ' Chip Select High        
      DIRA[AxCmDat] :=0             ' Data line set to input
      'done

PUB PulseCompass
      ' ----------------------------- Test Pulse ------------------
      waitcnt((5_000 + cnt))        ' Wait   
      OUTA[CmEN] := 0               ' Enable Down            
      waitcnt((5_000 + cnt))        ' Wait 
      OUTA[CmEN] := 1               ' Enable UP