{{
Rover Controller 1 v01 Top Object File

Set up TV functions
Set up Serial functions
        TxData
Set up PWM functions
}}

CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000
    
    'Receiver Transmitter Pins
 
  CS = 0  '    CS         '[~CS] Chip select - active lo
  DI = 1  '    DI         ' [DI] Data Input pin from Prop to AD
  CL = 2  '    CL         ' [CLK] Clock Pin
  DO = 3  '    DO         ' [DO] Data Output from AD to Prop 
  SE = 16 '    SE         '[~SE] control line Active low
  
  Avbit0   = 4
  Avbit1   = 5
  Avbit2   = 6
  Avbit3   = 7

  AxCmDat = 8   ' [Dxx] Data I/O line for compass and axcelerometer
  CmEN  = 9     ' [~EN] Compass Enable Line 
  AxcCS = 10    ' [~CS] Axcelerometer Chip Select
  AxcZG = 11    ' [ZG] Axcel Zero G indicator - Free Fall
      
  txpin = 24   ' Trans PDN (low disables Transmitter)
  txPDN = 25   ' Trans data 
  rxPDN = 26  ' rec PDN (low disables receiver) 
  rxpin = 27  ' rec data
  
  LeftServoFullStop = 1532
  RightServoFullStop = 1572
  DeadBand = 10
      
var
  byte ChecksumIN
  byte Checksum
  
  byte Dat0,DatNew0           ' Inbound data byte 0 
  byte Dat1,DatNew1           ' Inbound data byte 1
  byte Dat2,DatNew2           ' Inbound data byte 2
  byte Dat3,DatNew3           ' Inbound data byte 3
  byte ADCog , AD0,AD1,AD2,AD3,AD4,AD5,AD6,AD7,Buttons
  long CM0,CM1
  long Gx,Gy,Gz
  Long AX0,AX1,AX2,AX3
  byte Tx1,Tx2,Tx3,Tx4,ChecksumT,ChecksumR 
  word Srv0           ' Servo Output data 
  word Srv1    
  word Srv2
  word Srv3
  word CamAngle
  byte rxbyte
  byte Temp , CamStat

  long ADStack[16]  
  
OBJ
    Num   : "Numbers"
    TV    : "TV_Text"      
'    Ser   : "FullDuplexSerial"
    gr    : "graphics"
'    Servo : "Servo32v3"
    AD    : "ADC0838_axc"                     

PUB Start '|   rxbyte  , Temp
    TV.Start(12)                'Start TV Terminal
    DisplayBase
   ' ======================= Initialize Av selection bits =====================
    AVsetup
    Av0                         ' Turn on Controller
    
    ' ========================== Set up ports for RF communication and prep Tx & Rx   
    RadioSetup 

    ' ========================== Start Serial Communications ====================
    dira[txpin]~~                   ' Set tx Pin as output
    dira[rxpin]~                    ' Set rx pin as input
    'Ser.start(rxPin, txpin, 0, 4800)' Initialize Serial (rxpin, txpin, mode, baudrate)
    
    ' ========================== Start AD Converter routines ====================
   AD.init                      ' This includes AD - Axcelerometer and compass
    ' ========================== Initialize Number handling routines ====================
   Num.Init                    'Initialize Numbers        
    ' ========================== Start PWM - Servo drivers ===================
  'repeat Temp from 16 to 18      'Preset ALL servo's pin direction
  '  dira[Temp] ~~             

  'Servo.Start
  'CamAngle := 1500
  'repeat Temp from 16 to 18      'Preset ALL servo's to center position
  '    Servo.Set(Temp,1500)
  RxOn
  TxOff  
  'Ser.rxflush                   ' Flush the serial buffer
  CamAngle := 1340

  Main                          ' Start the Main loop

PUB Main  
  repeat
    Display1
    AD0 := AD.GetAD(0)
    AD1 := AD.GetAD(1)
    AD2 := AD.GetAD(2)
    AD3 := AD.GetAD(3)
    AD4 := AD.GetAD(4)
    AD5 := AD.GetAD(5)
    AD6 := AD.GetAD(6)
    AD7 := AD.GetAD(7)

    AX0 := AD.GetAX(0)
    AX1 := AD.GetAX(1)
    AX2 := AD.GetAX(2)
    AX3 := AD.GetAX(3)

    CM0 := AD.GetCompass(0) 
    CM1 := AD.GetCompass(0)

    if AX0 < AX3
      Gx :=  (AX0-AX3)
    else
      Gx :=-1 * (AX3-AX0) 

    if AX1 < AX3
      Gy := (AX1-AX3) 
    else
      Gy := -1 * (AX3-AX1) 

    if AX2 < AX3
      Gz := (AX2-AX3)
    else
      Gz := -1 * (AX3-AX2) 

    Gx := 100 * Gx/454
    Gy := 100 * Gy/454  
    Gz := 100 * Gz/454
        
PUB Display1
  TV.out($0C)                   ' set color (color follows)
  TV.Out(2)
  
  DisplayData (05,2,AD0)                                 'Line 1 data
  DisplayData (14,2,AD1)
  DisplayData (23,2,AD2)
  DisplayData (32,2,AD3)

  DisplayData (05,3,AD4)                                 'Line 2 data
  DisplayData (14,3,AD5)
  DisplayData (23,3,AD6)
  DisplayData (32,3,AD7)

  TV.out($0B)                   'set Y position for buttons line of data
  Tv.out(5)

      TV.out($0A)                   'set X position (X follows)
      Tv.out(3)
      TV.Str(string("     "))
      TV.out($0A)                   'set X position (X follows)
      Tv.out(13)
      TV.Str(string("     "))
      TV.out($0A)                   'set X position (X follows)
      Tv.out(23)
      TV.Str(string("     "))
      TV.out($0A)                   'set X position (X follows)
      Tv.out(33)
      TV.Str(string("     "))
       
  DisplayData (03,5,Gx)                     ' Line 2 Data
  DisplayData (13,5,Gy)
  DisplayData (23,5,Gz)                     ' Line 2 Data
  DisplayData (33,5,AX3)

  DisplayData (10,6,CM0)                     ' Line 2 Data
  DisplayData (20,6,CM1)                        
 
  TV.out($0B)                   'set Y position for buttons line of data
  Tv.out(7)

  if (Buttons & 1 ) <> 0
      TV.out($0A)                   'set X position (X follows)
      Tv.out(5)
      TV.Str(string(" ON "))
  else
      TV.out($0A)                   'set X position (X follows)
      Tv.out(5)
      TV.Str(string(" off")) 

  if (Buttons & 2 ) <> 0
      TV.out($0A)                   'set X position (X follows)
      Tv.out(15)
      TV.Str(string(" ON "))
  else
      TV.out($0A)                   'set X position (X follows)
      Tv.out(15)
      TV.Str(string(" off")) 

  if (Buttons & 4 ) <> 0

      TV.out($0A)                   'set X position (X follows)
      Tv.out(25)
      TV.Str(string(" ON "))
  else
      TV.out($0A)                   'set X position (X follows)
      Tv.out(25)
      TV.Str(string(" off")) 

  DisplayData (32,7,Buttons)

    DisplayData (6,11,Tx1) 
    DisplayData (11,11,Tx2)
    DisplayData (16,11,Tx3)
    DisplayData (21,11,Tx4) 
    DisplayData (26,11,ChecksumT)

  TV.out($0C)                   ' set color (color follows)
  TV.Out(4)

    DisplayData (6,12,Dat0) 
    DisplayData (11,12,Dat1)
    DisplayData (16,12,Dat2)
    DisplayData (21,12,Dat3) 
    DisplayData (26,12,ChecksumR)

pub DisplayBase
  
    TV.Out(00)                'home TV Terminal
    TV.Str(string("==== Cannibal Robotics Rover v2.09a ==="))
    TV.Out(13)
    TV.Str(string("======================================="))  
    TV.Out(13)

    TV.Str(string("|AD0:    |AD1:    |AD2:    |AD3:     |"))    
    TV.Out(13)
    TV.Str(string("|AD4:    |AD5:    |AD6:    |AD7:     |")) 
    TV.Out(13)
    TV.Str(string("---------------------------------------"))
    TV.Out(13)
    TV.Str(string("Accel X:     Y:     Z:     v:   "))    
    TV.Out(13)
    TV.Str(string("Compass:     "))    
    TV.Out(13)
    TV.Str(string("Btn0:     Btn1:     Btn2:     "))   
    TV.Out(13)
    TV.Out(13) 
    TV.Out(13) 
    TV.Out(13) 
    TV.Str(string("Xmit:     +    +    +    =     chksum"))
    TV.Out(13)
    TV.Str(string("Rcev:     +    +    +    =     chksum"))

   ' TV.Str(string("Signal: "))                
   ' TV.Str(Num.ToStr (AD.GetAD(0, CL , CS , DI , DO), Num#DDEC))
   ' TV.Out(13)

PUB RadioSetup                  '(txPDN,rxPDN,txpin,rxpin)
    dira[txPDN]~~                     'Set pin as output Transmitter PDN
    dira[rxPDN]~~                     'Set pin as output Reciever PDN
    dira[txpin]~~                     'Set pin as output Transmitter data
    dira[rxpin]~                     'Set pin as input Reciever data

    outa[txPDN]~                      'Turn off Transmitter
    outa[rxPDN]~                      'Turn off reciever

PUB RxON                        '(txPDN,rxPDN,txpin,rxpin)
    outa[txPDN] := 0                      'Turn OFF Transmitter
    outa[rxPDN] := 1                      'Turn ON local reciever     

PUB TxON                        '(txPDN,rxPDN,txpin,rxpin)
    outa[rxPDN] := 0                     'Turn OFF local reciever
    outa[txPDN] := 1                     'Turn ON Transmitter    

PUB RxOFF                        '(txPDN,rxPDN,txpin,rxpin)
    outa[rxPDN] := 0                      'Turn OFF local reciever     

PUB TxOFF                        '(txPDN,rxPDN,txpin,rxpin)
    outa[txPDN] := 0                     'Turn ON Transmitter

PUB AvSetup
    DIRA[Avbit0] ~~
    DIRA[Avbit1] ~~
    DIRA[Avbit2] ~~
    DIRA[Avbit3] ~~
    outa[Avbit0] := 0
    outa[Avbit1] := 0
    outa[Avbit2] := 0
    outa[Avbit3] := 0
    
PUB Av0
    outa[Avbit0] := 1
    outa[Avbit1] := 0
    outa[Avbit2] := 0
    outa[Avbit3] := 0 
PUB Av1
    outa[Avbit0] := 0
    outa[Avbit1] := 1
    outa[Avbit2] := 0
    outa[Avbit3] := 0
PUB Av2
    outa[Avbit0] := 0
    outa[Avbit1] := 0
    outa[Avbit2] := 1
    outa[Avbit3] := 0
PUB Av3
    outa[Avbit0] := 0
    outa[Avbit1] := 0
    outa[Avbit2] := 0
    outa[Avbit3] := 1
    
Pri DisplayData (X,Y,Data)
  TV.out($0B)                   'set Y position (Y follows)
  Tv.out(Y)
  TV.out($0A)                   'set X position (X follows)
  Tv.out(X)
  TV.Str(string("    "))        ' Blank old number
  TV.out($0A)                   'set X position (X follows)
  Tv.out(X)
  TV.Str(Num.ToStr (Data, Num#DDEC))